; flat assembler interface for Dex4u
; Copyright (c) 1999-2006, Tomasz Grysztar.
; All rights reserved.

use32
	ORG   0x400000

	jmp   start
	db    'DEX2'

start:
	mov   ax,18h
	mov   ds,ax
	mov   es,ax
	mov   eax,[return]
	mov   [eax],esp
	mov   esp,Stack1	     ; 0x200000 -64k

 ;----------------------------------------------------;
 ; Get calltable address.                             ;
 ;----------------------------------------------------;
	mov   edi,Functions
	mov   al,0
	mov   ah,0x0a
	int   40h

	call  [GetParams]
	add   esi,4 ;12
	mov   dword[command_line],esi

	mov   edi,Filehandle
	mov   ecx,320
	mov   al,0
	rep   stosb
	call  [DriveLetter]
	mov   [Drive],al
	mov   esi,_logo 	
	call  [PrintString]

	mov   [AdressAddOn],0
	call  init_memory 
	call  get_params   
	jc    information
	call  [TimerSecondCount]
	mov   [start_time],eax
	call  preprocessor
	call  parser
	call  assembler
	call  formatter


	call  display_user_messages
	movzx eax,[current_pass]
	inc   eax
	call  display_number
	mov   esi,_passes_suffix
	call  [PrintString]
	call  [TimerSecondCount]
	sub   eax,[start_time]
	mov   ebx,100
	mul   ebx
	mov   ebx,182
	div   ebx
	or    eax,eax
	jz    display_bytes_count
	xor   edx,edx
	mov   ebx,10
	div   ebx
	push  edx
	call  display_number
	mov   al,'.'
	call  display_character1
	pop   eax
	call  display_number
	mov   esi,_seconds_suffix
	call  [PrintString]
display_bytes_count:
	mov   eax,[written_size]
	call  display_number
	mov   esi,_bytes_suffix
	call  [PrintString]
	xor   al,al
	jmp   exit_program

;----------------------------------------------------;
; information.                                       ;
;----------------------------------------------------;
information:
	mov   esi,_usage
	call  [PrintString]
	mov   al,1
	jmp   exit_program

;----------------------------------------------------;
; get_params.                                        ;
;----------------------------------------------------;
get_params:
	mov   esi,[command_line]
	mov   edi,StartProg
	mov   [input_file],0
	mov   [output_file],0
	;mov   [memory_setting],0
	mov   [passes_limit],100
	lodsb
	cmp   al,'.'
	jne   Try20H
	add   [command_line],4
	mov   esi,[command_line]
	lodsb
Try20H:
	cmp   al,' '
	jne   bad_params
	lodsb
	cmp   al,0x1f
	jbe   bad_params
	cmp   al,0x80
	jae   bad_params
	cmp   al,' '
	je    bad_params
	stosb
	mov   cx,7
Cliloop: 
	lodsb
	cmp   al,'.'
	je    DoExt1
	stosb
	loop  Cliloop
	lodsb
	cmp   al,'.'
	jne   bad_params
DoExt1:
	stosb
	mov   cx,3
	rep   movsb
	mov   al,0
	stosb
	lodsb
	cmp   al,' '
	jne   get_paramsNoOutPutFile_ok
	lodsb
	mov   edi,EndProg
	stosb
	mov   cx,7
Cliloop1: 
	lodsb
	cmp   al,'.'
	je    DoExt2
	stosb
	loop  Cliloop1
	lodsb
	cmp   al,'.'
	jne   bad_params
DoExt2:
	stosb
	mov   cx,3
	rep   movsb
	mov   al,0
	stosb
get_params_ok:
	mov   [input_file],StartProg
	mov   [output_file],EndProg
	clc
	ret

get_paramsNoOutPutFile_ok:
	mov   [input_file],StartProg
	mov   [output_file],0
	clc
	ret

bad_params:
	stc
	ret
Drive		  db   0
return		  dd   0
start_time	  dd   0
command_line	  dd   0
ExitMesage:	  db   13,13,'Press any key to exit fasm',0

include 'system.inc'

include 'version.inc'

_copyright db 'Copyright (c) 1999-2005, Tomasz Grysztar',13,0
_logo db 'flat assembler  version ',VERSION_STRING,13,0
_usage db 'usage: fasm source [output]',13,0 
_testfasm db 'Press any key to test!',13,13,0 

_passes_suffix db ' passes, ',0
_seconds_suffix db ' seconds, ',0
_bytes_suffix db ' bytes.',13,0

include 'errors.inc'
include 'expressi.inc'
include 'preproce.inc'
include 'parser.inc'
include 'assemble.inc'
include 'formats.inc'
include 'x86_64.inc'


align 4

include 'variable.inc'

StartProg:	  rb   80
EndProg:	  rb   80

include 'Dex.inc'		 ; Here is where we includ our "DexFunctions.inc" file
Stack2:  rb 1024*64
Stack1:  rb 1024		 ; remember the stack works backward
include 'Filehand.inc'
buffer rb 1000h